#include "tex.h"


Texture::Texture(char* filename, int tile)
{
	char filen[100];
	sprintf(filen,"./%s\0",filename);
	FILE* file = fopen(filen, "rb");

	char coltype;
	//fscanf(file,"%c%c%c",&coltype,&width,&height);
	width=0;
	height = 0;
	fscanf(file,"%c",&coltype);
	fscanf(file,"%c",&width);
	fscanf(file,"%c",&height);


	bytes = width * height * 4;

	texData = new unsigned char[bytes];

	if (coltype == 'b')
	{
		int iter = bytes / 4;
		int pos = 0;
		for (int x = 0; x < iter; x++)
		{
			unsigned char data;
			fscanf(file,"%c",&data);
			texData[pos] = data;
			texData[pos+1] = data;
			texData[pos+2] = data;
			texData[pos+3] = data;
			pos += 4;
		}
	}
	else
	if (coltype == 'c')
	{		
		for (int x = 0; x < bytes; x++)
		{
			unsigned char data;
			fscanf(file,"%c",&data);
			texData[x] = data;
			x++;
			fscanf(file,"%c",&data);
			texData[x] = data;
			x++;			
			fscanf(file,"%c",&data);
			texData[x] = data;
			x++;
			texData[x] = 255;
		}
	}
	else
	{
		char buf[100];
		sprintf(buf,"Corrupted Texture File: %s\0",filename);
		errorWindow(buf);
		closeWindow();
	}

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_2D, texture);

	int tileformat = GL_CLAMP;
	if (tile) tileformat = GL_REPEAT;

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, tileformat);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, tileformat);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);

	//glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, texData);
	int err = gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA8, width, height, GL_RGBA, GL_UNSIGNED_BYTE, texData);
	if (err)
	{
		errorWindow("Error building mipmaps.");
		closeWindow();
	}
}

Texture::~Texture()
{
	glDeleteTextures(1, &texture);
	if (texData != NULL) delete[] texData;
}

void Texture::enable()
{
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texture);
}

void Texture::disable()
{
	glDisable(GL_TEXTURE_2D);
}